
struct op_code {
  char	opcode[10];
  int	value;
  int	length;
  int	type;
  int	mode;
} ;



struct op_code opcodes[256] = {

	{"NEG",		0x00, 2, 0, 7},
	{"???",		0x01, 1, 0, 0},
	{"???",		0x02, 1, 0, 0},
	{"COM",		0x03, 2, 1, 7},
	{"LSR",		0x04, 2, 4, 7},
	{"???",		0x05, 1, 0, 0},
	{"ROR",		0x06, 2, 0, 7},
	{"ASR",		0x07, 2, 0, 7},
	{"ASL",		0x08, 2, 0, 7},
	{"ROL",		0x09, 2, 0, 7},
	{"DEC",		0x0a, 2, 0, 7},
	{"???",		0x0b, 1, 0, 0},
	{"INC",		0x0c, 2, 0, 7},
	{"TST",		0x0d, 2, 0, 7},
	{"JMP",		0x0e, 2, 0, 7},
	{"CLR",		0x0f, 2, 0, 7},

	{"",		0x10, 1, 0, 1},
	{"",		0x11, 1, 0, 1},
	{"NOP",		0x12, 1, 2, 5},
	{"SYNC",	0x13, 1, 1, 5},
	{"???",		0x14, 1, 3, 0},
	{"???",		0x15, 1, 0, 0},
	{"LBRA",	0x16, 3, 2, 8},
	{"LBSR",	0x17, 3, 0, 8},
	{"???",		0x18, 1, 0, 0},
	{"DAA",		0x19, 1, 0, 5},
	{"ORCC",	0x1a, 2, 0, 1},
	{"???",		0x1b, 1, 0, 0},
	{"ANDCC",	0x1c, 2, 0, 1},
	{"SEX",		0x1d, 1, 0, 5},
	{"EXG",		0x1e, 2, 0, 10},
	{"TFR",		0x1f, 2, 0, 10},

	{"BRA",		0x20, 2, 0, 2},
	{"BRN",		0x21, 2, 0, 2},
	{"BHI",		0x22, 2, 0, 2},
	{"BLS",		0x23, 2, 1, 2},
	{"BCC",		0x24, 2, 4, 2},
	{"BCS",		0x25, 2, 0, 2},
	{"BNE",		0x26, 2, 2, 2},
	{"BEQ",		0x27, 2, 0, 2},
	{"BVC",		0x28, 2, 0, 2},
	{"BVS",		0x29, 2, 0, 2},
	{"BPL",		0x2a, 2, 0, 2},
	{"BMI",		0x2b, 2, 0, 2},
	{"BGE",		0x2c, 2, 0, 2},
	{"BLT",		0x2d, 2, 0, 2},
	{"BGT",		0x2e, 2, 0, 2},
	{"BLE",		0x2f, 2, 0, 2},

	{"LEAX",    0x30, 2, 0, 3},
	{"LEAY",    0x31, 2, 0, 3},
	{"LEAS",	0x32, 2, 2, 3},
	{"LEAU",	0x33, 2, 0, 3},
	{"PSHS",	0x34, 2, 3, 9},
	{"PULS",	0x35, 2, 0, 9},
	{"PSHU",	0x36, 2, 2, 9},
	{"PULU",	0x37, 2, 0, 9},
	{"???",		0x38, 1, 0, 0},
	{"RTS",		0x39, 1, 0, 5},
	{"ABX",		0x3a, 1, 0, 5},
	{"RTI",		0x3b, 1, 0, 5},
	{"CWAI",	0x3c, 2, 0, 5},
	{"MUL",		0x3d, 1, 0, 5},
	{"???",		0x3e, 1, 0, 0},
	{"SWI",		0x3f, 1, 0, 5},

	{"NEGA",	0x40, 1, 0, 5},
	{"???",		0x41, 1, 0, 0},
	{"???",		0x42, 1, 0, 0},
	{"COMA",	0x43, 1, 1, 5},
	{"LSRA",	0x44, 1, 4, 5},
	{"???",		0x45, 1, 0, 0},
	{"RORA",	0x46, 1, 2, 5},
	{"ASRA",	0x47, 1, 0, 5},
	{"ASLA",	0x48, 1, 0, 5},
	{"ROLA",	0x49, 1, 0, 5},
	{"DECA",	0x4a, 1, 0, 5},
	{"???",		0x4b, 1, 0, 0},
	{"INCA",	0x4c, 1, 0, 5},
	{"TSTA",    0x4d, 1, 0, 5},
	{"???",		0x4e, 1, 0, 0},
	{"CLRA",    0x4f, 1, 0, 5},

	{"NEGB",    0x50, 1, 0, 5},
	{"???",		0x51, 1, 0, 0},
	{"???",		0x52, 1, 2, 0},
   	{"COMB",    0x53, 1, 1, 5},
	{"LSRB",    0x54, 1, 3, 5},
	{"???",		0x55, 1, 0, 0},
	{"RORB",	0x56, 1, 2, 5},
	{"ASRB",	0x57, 1, 0, 5},
	{"ASLB",    0x58, 1, 0, 5},
	{"ROLB",	0x59, 1, 0, 5},
	{"DECB",	0x5a, 1, 0, 5},
	{"???",		0x5b, 1, 0, 0},
	{"INCB",	0x5c, 1, 0, 5},
	{"TSTB",	0x5d, 1, 0, 5},
	{"???",		0x5e, 1, 0, 0},
	{"CLRB",	0x5f, 1, 0, 5},

	{"NEG",		0x60, 2, 0, 3},
	{"???",		0x61, 1, 0, 0},
	{"???",		0x62, 1, 0, 0},
	{"COM",		0x63, 2, 0, 3},
	{"LSR",		0x64, 2, 4, 3},
	{"???",		0x65, 1, 0, 0},
	{"ROR",  	0x66, 2, 0, 3},
	{"ASR",		0x67, 2, 0, 3},
	{"ASL",		0x68, 2, 0, 3},
	{"ROL",		0x69, 2, 0, 3},
	{"DEC",		0x6a, 2, 0, 3},
	{"???",		0x6b, 1, 0, 0},
	{"INC",		0x6c, 2, 0, 3},
	{"TST",		0x6d, 2, 0, 3},
	{"JMP",		0x6e, 2, 0, 3},
	{"CLR",		0x6f, 2, 0, 3},

	{"NEG",		0x70, 3, 0, 4},
	{"???",		0x71, 1, 0, 0},
	{"???",		0x72, 1, 2, 0},
	{"COM",		0x73, 3, 0, 4},
	{"LSR",		0x74, 3, 3, 4},
	{"???",		0x75, 1, 0, 0},
	{"ROR",		0x76, 3, 2, 4},
	{"ASR",		0x77, 3, 0, 4},
	{"ASL",		0x78, 3, 0, 4},
	{"ROL",		0x79, 3, 0, 4},
	{"DEC",		0x7a, 3, 0, 4},
	{"???",		0x7b, 1, 0, 0},
	{"INC",		0x7c, 3, 0, 4},
	{"TST",		0x7d, 3, 0, 4},
	{"JMP",		0x7e, 3, 0, 4},
	{"CLR",		0x7f, 3, 0, 4},

	{"SUBA",	0x80, 2, 0, 1},
	{"CMPA",	0x81, 2, 0, 1},
	{"SBCA",	0x82, 2, 0, 1},
	{"SUBD",	0x83, 3, 0, 6},
	{"ANDA",    0x84, 2, 4, 1},
	{"BITA",	0x85, 2, 0, 1},
	{"LDA",		0x86, 2, 2, 1},
	{"???",		0x87, 1, 0, 0},
	{"EORA",    0x88, 2, 1, 1},
	{"ADCA",	0x89, 2, 1, 1},
	{"ORA",		0x8a, 2, 1, 1},
	{"ADDA",	0x8b, 2, 1, 1},
	{"CMPX",	0x8c, 3, 0, 6},
	{"BSR",		0x8d, 2, 0, 2},
	{"LDX",		0x8e, 3, 0, 6},
	{"???",		0x8f, 1, 0, 0},

	{"SUBA",	0x90, 2, 0, 7},
	{"CMPA",	0x91, 2, 0, 7},
	{"SBCA",	0x92, 2, 2, 7},
	{"SUBD",	0x93, 2, 0, 7},
	{"ANDA",	0x94, 2, 3, 7},
	{"BITA",	0x95, 2, 0, 7},
	{"LDA",		0x96, 2, 2, 7},
	{"STA",		0x97, 2, 0, 7},
	{"EORA",	0x98, 2, 1, 7},
	{"ADCA",	0x99, 2, 1, 7},
	{"ORA",		0x9a, 2, 1, 7},
	{"ADDA",	0x9b, 2, 1, 7},
	{"CMPX",	0x9c, 2, 1, 7},
	{"JSR",		0x9d, 2, 1, 7},
	{"LDX",		0x9e, 2, 1, 7},
	{"STX",		0x9f, 2, 1, 7},

	{"SUBA",	0x0a0, 2, 0, 3},
	{"CMPA",	0x0a1, 2, 0, 3},
	{"SBCA",	0x0a2, 2, 0, 3},
	{"SUBD",	0x0a3, 2, 0, 3},
	{"ANDA",	0x0a4, 2, 4, 3},
	{"BITA",	0x0a5, 2, 0, 3},
	{"LDA",		0x0a6, 2, 0, 3},
	{"STA",		0x0a7, 2, 0, 3},
	{"EORA",	0x0a8, 2, 0, 3},
	{"ADCA",	0x0a9, 2, 0, 3},
	{"ORA",		0x0aa, 2, 0, 3},
	{"ADDA",	0x0ab, 2, 0, 3},
	{"CMPX",	0x0ac, 2, 0, 3},
	{"JSR",		0x0ad, 2, 0, 3},
	{"LDX",		0x0ae, 2, 0, 3},
	{"STX",		0x0af, 2, 0, 3},

	{"SUBA",	0x0b0, 3, 1, 4},
	{"CMPA",	0x0b1, 3, 1, 4},
	{"SBCA",	0x0b2, 3, 2, 4},
	{"SUBD",	0x0b3, 3, 5, 4},
	{"ANDA",	0x0b4, 3, 3, 4},
	{"BITA",	0x0b5, 3, 0, 4},
	{"LDA",		0x0b6, 3, 2, 4},
	{"STA",		0x0b7, 3, 0, 4},
	{"EORA",	0x0b8, 3, 1, 4},
	{"ADCA",	0x0b9, 3, 1, 4},
	{"ORA",		0x0ba, 3, 1, 4},
	{"ADDA",	0x0bb, 3, 1, 4},
	{"CMPX",	0x0bc, 3, 1, 4},
	{"JSR",		0x0bd, 3, 1, 4},
	{"LDX",		0x0be, 3, 1, 4},
	{"STX",		0x0bf, 3, 1, 4},

	{"SUBB",	0x0c0, 2, 0, 1},
	{"CMPB",	0x0c1, 2, 0, 1},
	{"SBCB",	0x0c2, 2, 0, 1},
	{"ADDD",	0x0c3, 3, 0, 6},
	{"ANDB",	0x0c4, 2, 4, 1},
	{"BITB",	0x0c5, 2, 0, 1},
	{"LDB",		0x0c6, 2, 2, 1},
	{"???",		0x0c7, 1, 0, 0},
	{"EORB",	0x0c8, 2, 0, 1},
	{"ADCB",	0x0c9, 2, 0, 1},
	{"ORB",		0x0ca, 2, 0, 1},
	{"ADDB",	0x0cb, 2, 0, 1},
	{"LDD",		0x0cc, 3, 0, 6},
	{"???",		0x0cd, 1, 0, 0},
	{"LDU",		0x0ce, 3, 0, 6},
	{"???",		0x0cf, 1, 0, 0},

	{"SUBB",	0x0d0, 2, 0, 7},
	{"CMPB",	0x0d1, 2, 0, 7},
	{"SBCB",	0x0d2, 2, 2, 7},
	{"ADDD",	0x0d3, 2, 1, 7},
	{"ANDB",	0x0d4, 2, 3, 7},
	{"BITB",	0x0d5, 2, 0, 7},
	{"LDB",		0x0d6, 2, 2, 7},
	{"STB",		0x0d7, 2, 0, 7},
	{"EORB",	0x0d8, 2, 0, 7},
	{"ADCB",	0x0d9, 2, 0, 7},
	{"ORB",		0x0da, 2, 0, 7},
	{"ADDB",	0x0db, 2, 0, 7},
	{"LDD",		0x0dc, 2, 0, 7},
	{"STD",		0x0dd, 2, 0, 7},
	{"LDU",		0x0de, 2, 0, 7},
	{"STU",		0x0df, 2, 0, 7},

	{"SUBB",	0x0e0, 2, 0, 3},
	{"CMPB",	0x0e1, 2, 0, 3},
	{"SBCB",	0x0e2, 2, 0, 3},
	{"ADDD",	0x0e3, 2, 0, 3},
	{"ANDB",	0x0e4, 2, 4, 3},
	{"BITB",	0x0e5, 2, 0, 3},
	{"LDB",		0x0e6, 2, 2, 3},
	{"STB",		0x0e7, 2, 0, 3},
	{"EORB",    0x0e8, 2, 2, 3},
	{"ADCB",	0x0e9, 2, 2, 3},
	{"ORB",		0x0ea, 2, 2, 3},
	{"ADDB",	0x0eb, 2, 2, 3},
	{"LDD",		0x0ec, 2, 2, 3},
	{"STD",		0x0ed, 2, 2, 3},
	{"LDU",		0x0ee, 2, 2, 3},
	{"STU",		0x0ef, 2, 2, 3},

	{"SUBB",	0x0f0, 3, 0, 4},
	{"CMPB",	0x0f1, 3, 0, 4},
	{"SBCB",	0x0f2, 3, 2, 4},
	{"ADDD",	0x0f3, 3, 0, 4},
	{"ANDB",	0x0f4, 3, 3, 4},
	{"BITB",	0x0f5, 3, 0, 4},
	{"LDB",		0x0f6, 3, 2, 4},
	{"STB",		0x0f7, 3, 0, 4},
	{"EORB",	0x0f8, 3, 0, 4},
	{"ADCB",	0x0f9, 3, 0, 4},
	{"ORB",		0x0fa, 3, 0, 4},
	{"ADDB",	0x0fb, 3, 0, 4},
	{"LDD",		0x0fc, 3, 0, 4},
	{"STD",		0x0fd, 3, 0, 4},
	{"LDU",		0x0fe, 3, 0, 4},
	{"STU",		0x0ff, 3, 0, 4}
	
} ;

struct op_code opcodes2[256] = {

	"",		0x00, 2, 0, 1,
	"",		0x01, 1, 0, 1,
	"",		0x02, 1, 0, 1,
	"",		0x03, 2, 1, 2,
	"",		0x04, 2, 4, 2,
	"",		0x05, 1, 0, 1,
	"",		0x06, 2, 0, 1,
	"",		0x07, 2, 0, 1,
	"",		0x08, 2, 0, 1,
	"",		0x09, 2, 0, 1,
	"",		0x0a, 2, 0, 1,
	"",		0x0b, 1, 0, 1,
	"",		0x0c, 2, 0, 1,
	"",		0x0d, 2, 0, 1,
	"",		0x0e, 2, 0, 1,
	"",		0x0f, 2, 0, 1,

	"",		0x10, 1, 0, 1,
	"",		0x11, 1, 0, 1,
	"",		0x12, 1, 2, 2,
	"",		0x13, 1, 1, 2,
	"",		0x14, 1, 3, 2,
	"",		0x15, 1, 0, 1,
	"",		0x16, 3, 2, 2,
	"",		0x17, 3, 0, 1,
	"",		0x18, 1, 0, 1,
	"",		0x19, 1, 0, 1,
	"",		0x1a, 2, 0, 1,
	"",		0x1b, 1, 0, 1,
	"",		0x1c, 2, 0, 1,
	"",		0x1d, 1, 0, 1,
	"",		0x1e, 2, 0, 1,
	"",		0x1f, 2, 0, 1,

	"",		0x20, 1, 0, 1,
	"LBRN",		0x21, 4, 0, 8,
	"LBHI",		0x22, 4, 0, 8,
	"LBLS",		0x23, 4, 1, 8,
	"LBHS",		0x24, 4, 4, 8,
	"LBCS",		0x25, 4, 0, 8,
	"LBNE",		0x26, 4, 2, 8,
	"LBEQ",		0x27, 4, 0, 8,
	"LBVC",		0x28, 4, 0, 8,
	"LBVS",		0x29, 4, 0, 8,
	"LBPL",		0x2a, 4, 0, 8,
	"LBMI",		0x2b, 4, 0, 8,
	"LBGE",		0x2c, 4, 0, 8,
	"LBLT",		0x2d, 4, 0, 8,
	"LBGT",		0x2e, 4, 0, 8,
	"LBLE",		0x2f, 4, 0, 8,

	"",		0x30, 1, 0, 1,
	"",		0x31, 1, 0, 1,
	"",		0x32, 2, 2, 2,
	"",		0x33, 1, 0, 1,
	"",		0x34, 2, 3, 2,
	"",		0x35, 2, 0, 1,
	"",		0x36, 2, 2, 2,
	"",		0x37, 2, 0, 1,
	"",		0x38, 1, 0, 2,
	"",		0x39, 1, 0, 2,
	"",		0x3a, 1, 0, 2,
	"",		0x3b, 1, 0, 2,
	"",		0x3c, 2, 0, 2,
	"",		0x3d, 1, 0, 2,
	"",		0x3e, 1, 0, 2,
	"SWI2",		0x3f, 2, 0, 5,

	"",		0x40, 1, 0, 1,
	"",		0x41, 1, 0, 1,
	"",		0x42, 1, 0, 1,
	"",		0x43, 1, 1, 2,
	"",		0x44, 1, 4, 2,
	"",		0x45, 1, 0, 1,
	"",		0x46, 1, 2, 2,
	"",		0x47, 1, 0, 1,
	"",		0x48, 1, 0, 1,
	"",		0x49, 1, 0, 1,
	"",		0x4a, 1, 0, 1,
	"",		0x4b, 1, 0, 1,
	"",		0x4c, 1, 0, 1,
	"",		0x4d, 1, 0, 1,
	"",		0x4e, 1, 0, 1,
	"",		0x4f, 1, 0, 1,

	"",		0x50, 1, 0, 1,
	"",		0x51, 1, 0, 1,
	"",		0x52, 1, 2, 2,
	"",		0x53, 1, 1, 2,
	"",		0x54, 1, 3, 2,
	"",		0x55, 1, 0, 1,
	"",		0x56, 1, 2, 2,
	"",		0x57, 1, 0, 1,
	"",		0x58, 1, 0, 1,
	"",		0x59, 1, 0, 1,
	"",		0x5a, 1, 0, 1,
	"",		0x5b, 1, 0, 1,
	"",		0x5c, 1, 0, 1,
	"",		0x5d, 1, 0, 1,
	"",		0x5e, 1, 0, 1,
	"",		0x5f, 1, 0, 1,

	"",		0x60, 1, 0, 1,
	"",		0x61, 1, 0, 1,
	"",		0x62, 1, 0, 1,
	"",		0x63, 1, 0, 1,
	"",		0x64, 2, 4, 2,
	"",		0x65, 1, 0, 1,
	"",  		0x66, 1, 0, 1,
	"",		0x67, 1, 0, 1,
	"",		0x68, 1, 0, 1,
	"",		0x69, 1, 0, 1,
	"",		0x6a, 1, 0, 1,
	"",		0x6b, 1, 0, 1,
	"",		0x6c, 1, 0, 1,
	"",		0x6d, 1, 0, 1,
	"",		0x6e, 1, 0, 1,
	"",		0x6f, 1, 0, 1,

	"",		0x70, 3, 0, 1,
	"",		0x71, 1, 0, 1,
	"",		0x72, 1, 2, 2,
	"",		0x73, 3, 0, 1,
	"",		0x74, 3, 3, 2,
	"",		0x75, 1, 0, 1,
	"",		0x76, 3, 2, 2,
	"",		0x77, 3, 0, 1,
	"",		0x78, 3, 0, 1,
	"",		0x79, 3, 0, 1,
	"",		0x7a, 3, 0, 1,
	"",		0x7b, 1, 0, 1,
	"",		0x7c, 3, 0, 1,
	"",		0x7d, 3, 0, 1,
	"",		0x7e, 3, 0, 1,
	"",		0x7f, 3, 0, 1,

	"",		0x80, 2, 0, 1,
	"",		0x81, 2, 0, 1,
	"",		0x82, 2, 0, 1,
	"CMPD",		0x83, 4, 0, 6,
	"",		0x84, 2, 4, 2,
	"",		0x85, 2, 0, 1,
	"",		0x86, 2, 2, 2,
	"",		0x87, 1, 0, 1,
	"",		0x88, 2, 1, 2,
	"",		0x89, 2, 1, 2,
	"",		0x8a, 2, 1, 2,
	"",		0x8b, 2, 1, 2,
	"CMPY",		0x8c, 4, 0, 6,
	"",		0x8d, 2, 0, 2,
	"LDY",		0x8e, 4, 0, 6,
	"",		0x8f, 1, 0, 2,

	"",		0x90, 2, 0, 1,
	"",		0x91, 2, 0, 1,
	"",		0x92, 2, 2, 2,
	"CMPD",		0x93, 3, 0, 7,
	"",		0x94, 2, 3, 2,
	"",		0x95, 2, 0, 1,
	"",		0x96, 2, 2, 2,
	"",		0x97, 2, 0, 1,
	"",		0x98, 2, 1, 2,
	"",		0x99, 2, 1, 2,
	"",		0x9a, 2, 1, 2,
	"",		0x9b, 2, 1, 2,
	"CMPY",		0x9c, 3, 1, 7,
	"",		0x9d, 2, 1, 2,
	"LDY",		0x9e, 3, 1, 7,
	"STY",		0x9f, 3, 1, 7,

	"",		0x0a0, 1, 0, 1,
	"",		0x0a1, 1, 0, 1,
	"",		0x0a2, 1, 0, 1,
	"CMPD",		0x0a3, 3, 0, 3,
	"",		0x0a4, 2, 4, 2,
	"",		0x0a5, 1, 0, 1,
	"",		0x0a6, 1, 0, 1,
	"",		0x0a7, 1, 0, 1,
	"",		0x0a8, 1, 0, 1,
	"",		0x0a9, 1, 0, 1,
	"",		0x0aa, 1, 0, 1,
	"",		0x0ab, 1, 0, 1,
	"CMPY",		0x0ac, 3, 0, 3,
	"",		0x0ad, 1, 0, 1,
	"LDY",		0x0ae, 3, 0, 3,
	"STY",		0x0af, 3, 0, 3,

	"",		0x0b0, 3, 1, 2,
	"",		0x0b1, 3, 1, 2,
	"",		0x0b2, 3, 2, 2,
	"CMPD",		0x0b3, 4, 5, 4,
	"",		0x0b4, 3, 3, 2,
	"",		0x0b5, 3, 0, 1,
	"",		0x0b6, 3, 2, 2,
	"",		0x0b7, 3, 0, 1,
	"",		0x0b8, 3, 1, 2,
	"",		0x0b9, 3, 1, 2,
	"",		0x0ba, 3, 1, 2,
	"",		0x0bb, 3, 1, 2,
	"CMPY",		0x0bc, 4, 1, 4,
	"",		0x0bd, 3, 1, 2,
	"LDY",		0x0be, 4, 1, 4,
	"STY",		0x0bf, 4, 1, 4,

	"",		0x0c0, 2, 0, 1,
	"",		0x0c1, 2, 0, 1,
	"",		0x0c2, 2, 0, 1,
	"",		0x0c3, 3, 0, 1,
	"",		0x0c4, 2, 4, 2,
	"",		0x0c5, 2, 0, 1,
	"",		0x0c6, 2, 2, 2,
	"",		0x0c7, 1, 0, 1,
	"",		0x0c8, 2, 0, 1,
	"",		0x0c9, 2, 0, 1,
	"",		0x0ca, 2, 0, 1,
	"",		0x0cb, 2, 0, 1,
	"",		0x0cc, 3, 0, 1,
	"",		0x0cd, 1, 0, 1,
	"LDS",		0x0ce, 4, 0, 6,
	"",		0x0cf, 1, 0, 1,

	"",		0x0d0, 2, 0, 1,
	"",		0x0d1, 2, 0, 1,
	"",		0x0d2, 2, 2, 2,
	"",		0x0d3, 2, 1, 2,
	"",		0x0d4, 2, 3, 2,
	"",		0x0d5, 2, 0, 1,
	"",		0x0d6, 2, 2, 2,
	"",		0x0d7, 2, 0, 1,
	"",		0x0d8, 2, 0, 1,
	"",		0x0d9, 2, 0, 1,
	"",		0x0da, 2, 0, 1,
	"",		0x0db, 2, 0, 1,
	"",		0x0dc, 2, 0, 1,
	"",		0x0dd, 2, 0, 1,
	"LDS",		0x0de, 3, 0, 7,
	"STS",		0x0df, 3, 0, 7,

	"",		0x0e0, 1, 0, 1,
	"",		0x0e1, 1, 0, 1,
	"",		0x0e2, 1, 0, 1,
	"",		0x0e3, 1, 0, 2,
	"",		0x0e4, 2, 4, 2,
	"",		0x0e5, 1, 0, 1,
	"",		0x0e6, 2, 2, 2,
	"",		0x0e7, 1, 0, 1,
	"",		0x0e8, 2, 2, 2,
	"",		0x0e9, 2, 2, 2,
	"",		0x0ea, 2, 2, 2,
	"",		0x0eb, 2, 2, 2,
	"",		0x0ec, 2, 2, 2,
	"",		0x0ed, 2, 2, 2,
	"LDS",		0x0ee, 3, 2, 3,
	"STS",		0x0ef, 3, 2, 3,

	"",		0x0f0, 3, 0, 1,
	"",		0x0f1, 3, 0, 1,
	"",		0x0f2, 3, 2, 2,
	"",		0x0f3, 3, 0, 1,
	"",		0x0f4, 3, 3, 2,
	"",		0x0f5, 3, 0, 1,
	"",		0x0f6, 3, 2, 2,
	"",		0x0f7, 3, 0, 1,
	"",		0x0f8, 3, 0, 1,
	"",		0x0f9, 3, 0, 1,
	"",		0x0fa, 3, 0, 1,
	"",		0x0fb, 3, 0, 1,
	"",		0x0fc, 3, 0, 1,
	"",		0x0fd, 3, 0, 1,
	"LDS",		0x0fe, 4, 0, 4,
	"STS",		0x0ff, 4, 0, 4
	
} ;


struct op_code opcodes3[256] = {

	"",		0x00, 2, 0, 1,
	"",		0x01, 1, 0, 1,
	"",		0x02, 1, 0, 1,
	"",		0x03, 2, 1, 2,
	"",		0x04, 2, 4, 2,
	"",		0x05, 1, 0, 1,
	"",		0x06, 2, 0, 1,
	"",		0x07, 2, 0, 1,
	"",		0x08, 2, 0, 1,
	"",		0x09, 2, 0, 1,
	"",		0x0a, 2, 0, 1,
	"",		0x0b, 1, 0, 1,
	"",		0x0c, 2, 0, 1,
	"",		0x0d, 2, 0, 1,
	"",		0x0e, 2, 0, 1,
	"",		0x0f, 2, 0, 1,

	"",		0x10, 1, 0, 1,
	"",		0x11, 1, 0, 1,
	"",		0x12, 1, 2, 2,
	"",		0x13, 1, 1, 2,
	"",		0x14, 1, 3, 2,
	"",		0x15, 1, 0, 1,
	"",		0x16, 3, 2, 2,
	"",		0x17, 3, 0, 1,
	"",		0x18, 1, 0, 1,
	"",		0x19, 1, 0, 1,
	"",		0x1a, 2, 0, 1,
	"",		0x1b, 1, 0, 1,
	"",		0x1c, 2, 0, 1,
	"",		0x1d, 1, 0, 1,
	"",		0x1e, 2, 0, 1,
	"",		0x1f, 2, 0, 1,

	"",		0x20, 2, 0, 1,
	"",		0x21, 2, 0, 1,
	"",		0x22, 2, 0, 1,
	"",		0x23, 2, 1, 2,
	"",		0x24, 2, 4, 2,
	"",		0x25, 2, 0, 1,
	"",		0x26, 2, 2, 2,
	"",		0x27, 2, 0, 1,
	"",		0x28, 2, 0, 1,
	"",		0x29, 2, 0, 1,
	"",		0x2a, 2, 0, 1,
	"",		0x2b, 2, 0, 1,
	"",		0x2c, 2, 0, 1,
	"",		0x2d, 2, 0, 1,
	"",		0x2e, 2, 0, 1,
	"",		0x2f, 2, 0, 1,

	"",		0x30, 1, 0, 1,
	"",		0x31, 1, 0, 1,
	"",		0x32, 2, 2, 2,
	"",		0x33, 1, 0, 1,
	"",		0x34, 2, 3, 2,
	"",		0x35, 2, 0, 1,
	"",		0x36, 2, 2, 2,
	"",		0x37, 2, 0, 1,
	"",		0x38, 1, 0, 2,
	"",		0x39, 1, 0, 2,
	"",		0x3a, 1, 0, 2,
	"",		0x3b, 1, 0, 2,
	"",		0x3c, 2, 0, 2,
	"",		0x3d, 1, 0, 2,
	"",		0x3e, 1, 0, 2,
	"SWI3",		0x3f, 2, 0, 2,

	"",		0x40, 1, 0, 1,
	"",		0x41, 1, 0, 1,
	"",		0x42, 1, 0, 1,
	"",		0x43, 1, 1, 2,
	"",		0x44, 1, 4, 2,
	"",		0x45, 1, 0, 1,
	"",		0x46, 1, 2, 2,
	"",		0x47, 1, 0, 1,
	"",		0x48, 1, 0, 1,
	"",		0x49, 1, 0, 1,
	"",		0x4a, 1, 0, 1,
	"",		0x4b, 1, 0, 1,
	"",		0x4c, 1, 0, 1,
	"",		0x4d, 1, 0, 1,
	"",		0x4e, 1, 0, 1,
	"",		0x4f, 1, 0, 1,

	"",		0x50, 1, 0, 1,
	"",		0x51, 1, 0, 1,
	"",		0x52, 1, 2, 2,
	"",		0x53, 1, 1, 2,
	"",		0x54, 1, 3, 2,
	"",		0x55, 1, 0, 1,
	"",		0x56, 1, 2, 2,
	"",		0x57, 1, 0, 1,
	"",		0x58, 1, 0, 1,
	"",		0x59, 1, 0, 1,
	"",		0x5a, 1, 0, 1,
	"",		0x5b, 1, 0, 1,
	"",		0x5c, 1, 0, 1,
	"",		0x5d, 1, 0, 1,
	"",		0x5e, 1, 0, 1,
	"",		0x5f, 1, 0, 1,

	"",		0x60, 1, 0, 1,
	"",		0x61, 1, 0, 1,
	"",		0x62, 1, 0, 1,
	"",		0x63, 1, 0, 1,
	"",		0x64, 2, 4, 2,
	"",		0x65, 1, 0, 1,
	"",  		0x66, 1, 0, 1,
	"",		0x67, 1, 0, 1,
	"",		0x68, 1, 0, 1,
	"",		0x69, 1, 0, 1,
	"",		0x6a, 1, 0, 1,
	"",		0x6b, 1, 0, 1,
	"",		0x6c, 1, 0, 1,
	"",		0x6d, 1, 0, 1,
	"",		0x6e, 1, 0, 1,
	"",		0x6f, 1, 0, 1,

	"",		0x70, 3, 0, 1,
	"",		0x71, 1, 0, 1,
	"",		0x72, 1, 2, 2,
	"",		0x73, 3, 0, 1,
	"",		0x74, 3, 3, 2,
	"",		0x75, 1, 0, 1,
	"",		0x76, 3, 2, 2,
	"",		0x77, 3, 0, 1,
	"",		0x78, 3, 0, 1,
	"",		0x79, 3, 0, 1,
	"",		0x7a, 3, 0, 1,
	"",		0x7b, 1, 0, 1,
	"",		0x7c, 3, 0, 1,
	"",		0x7d, 3, 0, 1,
	"",		0x7e, 3, 0, 1,
	"",		0x7f, 3, 0, 1,

	"",		0x80, 2, 0, 1,
	"",		0x81, 2, 0, 1,
	"",		0x82, 2, 0, 1,
	"CMPU",		0x83, 4, 0, 6,
	"",		0x84, 2, 4, 2,
	"",		0x85, 2, 0, 1,
	"",		0x86, 2, 2, 2,
	"",		0x87, 1, 0, 1,
	"",		0x88, 2, 1, 2,
	"",		0x89, 2, 1, 2,
	"",		0x8a, 2, 1, 2,
	"",		0x8b, 2, 1, 2,
	"CMPS",		0x8c, 4, 0, 6,
	"",		0x8d, 2, 0, 2,
	"",		0x8e, 3, 0, 2,
	"",		0x8f, 1, 0, 2,

	"",		0x90, 2, 0, 1,
	"",		0x91, 2, 0, 1,
	"",		0x92, 2, 2, 2,
	"CMPU",		0x93, 2, 0, 2,
	"",		0x94, 2, 3, 2,
	"",		0x95, 2, 0, 1,
	"",		0x96, 2, 2, 2,
	"",		0x97, 2, 0, 1,
	"",		0x98, 2, 1, 2,
	"",		0x99, 2, 1, 2,
	"",		0x9a, 2, 1, 2,
	"",		0x9b, 2, 1, 2,
	"CMPS",		0x9c, 2, 1, 2,
	"",		0x9d, 2, 1, 2,
	"",		0x9e, 2, 1, 2,
	"",		0x9f, 2, 1, 2,

	"",		0x0a0, 1, 0, 1,
	"",		0x0a1, 1, 0, 1,
	"",		0x0a2, 1, 0, 1,
	"CMPU",		0x0a3, 1, 0, 2,
	"",		0x0a4, 2, 4, 2,
	"",		0x0a5, 1, 0, 1,
	"",		0x0a6, 1, 0, 1,
	"",		0x0a7, 1, 0, 1,
	"",		0x0a8, 1, 0, 1,
	"",		0x0a9, 1, 0, 1,
	"",		0x0aa, 1, 0, 1,
	"",		0x0ab, 1, 0, 1,
	"CMPS",		0x0ac, 1, 0, 1,
	"",		0x0ad, 1, 0, 1,
	"",		0x0ae, 1, 0, 1,
	"",		0x0af, 1, 0, 1,

	"",		0x0b0, 3, 1, 2,
	"",		0x0b1, 3, 1, 2,
	"",		0x0b2, 3, 2, 2,
	"CMPU",		0x0b3, 4, 5, 2,
	"",		0x0b4, 3, 3, 2,
	"",		0x0b5, 3, 0, 1,
	"",		0x0b6, 3, 2, 2,
	"",		0x0b7, 3, 0, 1,
	"",		0x0b8, 3, 1, 2,
	"",		0x0b9, 3, 1, 2,
	"",		0x0ba, 3, 1, 2,
	"",		0x0bb, 3, 1, 2,
	"CMPS",		0x0bc, 4, 1, 2,
	"",		0x0bd, 3, 1, 2,
	"",		0x0be, 3, 1, 2,
	"",		0x0bf, 3, 1, 2,

	"",		0x0c0, 2, 0, 1,
	"",		0x0c1, 2, 0, 1,
	"",		0x0c2, 2, 0, 1,
	"",		0x0c3, 3, 0, 1,
	"",		0x0c4, 2, 4, 2,
	"",		0x0c5, 2, 0, 1,
	"",		0x0c6, 2, 2, 2,
	"",		0x0c7, 1, 0, 1,
	"",		0x0c8, 2, 0, 1,
	"",		0x0c9, 2, 0, 1,
	"",		0x0ca, 2, 0, 1,
	"",		0x0cb, 2, 0, 1,
	"",		0x0cc, 3, 0, 1,
	"",		0x0cd, 1, 0, 1,
	"",		0x0ce, 3, 0, 1,
	"",		0x0cf, 1, 0, 1,

	"",		0x0d0, 2, 0, 1,
	"",		0x0d1, 2, 0, 1,
	"",		0x0d2, 2, 2, 2,
	"",		0x0d3, 2, 1, 2,
	"",		0x0d4, 2, 3, 2,
	"",		0x0d5, 2, 0, 1,
	"",		0x0d6, 2, 2, 2,
	"",		0x0d7, 2, 0, 1,
	"",		0x0d8, 2, 0, 1,
	"",		0x0d9, 2, 0, 1,
	"",		0x0da, 2, 0, 1,
	"",		0x0db, 2, 0, 1,
	"",		0x0dc, 2, 0, 1,
	"",		0x0dd, 2, 0, 1,
	"",		0x0de, 2, 0, 1,
	"",		0x0df, 2, 0, 1,

	"",		0x0e0, 1, 0, 1,
	"",		0x0e1, 1, 0, 1,
	"",		0x0e2, 1, 0, 1,
	"",		0x0e3, 1, 0, 2,
	"",		0x0e4, 2, 4, 2,
	"",		0x0e5, 1, 0, 1,
	"",		0x0e6, 2, 2, 2,
	"",		0x0e7, 1, 0, 1,
	"",		0x0e8, 2, 2, 2,
	"",		0x0e9, 2, 2, 2,
	"",		0x0ea, 2, 2, 2,
	"",		0x0eb, 2, 2, 2,
	"",		0x0ec, 2, 2, 2,
	"",		0x0ed, 2, 2, 2,
	"",		0x0ee, 2, 2, 2,
	"",		0x0ef, 2, 2, 2,

	"",		0x0f0, 3, 0, 1,
	"",		0x0f1, 3, 0, 1,
	"",		0x0f2, 3, 2, 2,
	"",		0x0f3, 3, 0, 1,
	"",		0x0f4, 3, 3, 2,
	"",		0x0f5, 3, 0, 1,
	"",		0x0f6, 3, 2, 2,
	"",		0x0f7, 3, 0, 1,
	"",		0x0f8, 3, 0, 1,
	"",		0x0f9, 3, 0, 1,
	"",		0x0fa, 3, 0, 1,
	"",		0x0fb, 3, 0, 1,
	"",		0x0fc, 3, 0, 1,
	"",		0x0fd, 3, 0, 1,
	"",		0x0fe, 3, 0, 1,
	"",		0x0ff, 3, 0, 1
	
} ;
